/*
    This file is part of the FElt finite element analysis package.
    Copyright (C) 1993-2000 Jason I. Gobat and Darren C. Atkinson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/************************************************************************
 * File:	array.h							*
 *									*
 * Description:	This file contains the function and type declarations	*
 *		for array blocks.					*
 ************************************************************************/

# ifndef _ARRAY_H
# define _ARRAY_H
# include "proto.h"			/* function declarations */

typedef struct array {
    void *ptr;				/* pointer to data    */
    short type;				/* element type code  */
    short temp;				/* temporary flag     */
    short length;			/* length of array    */
    short handler;			/* handler index      */
    short elt_size;			/* size of an element */
    short ref_count;			/* reference count    */
} *Array;


extern Array CreateArray  PROTO ((void *, int, int, int));
extern Array CopyArray	  PROTO ((Array));
extern void  DestroyArray PROTO ((Array));

# endif /* _ARRAY_H */
